"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Field = void 0;
const react_1 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const Checkbox_1 = require("@procyon/components/Checkbox");
const DatePicker_1 = require("@procyon/components/DatePicker");
const RadioButton_1 = require("@procyon/components/RadioButton");
const Selectbox_1 = require("@procyon/components/Selectbox");
const TextField_1 = require("@procyon/components/TextField");
const TimePicker_1 = require("@procyon/components/TimePicker");
const enums_1 = require("@procyon/types/enums");
const utils_1 = require("@procyon/utils");
const ValidationMessage_1 = require("./ValidationMessage");
const Field = (props) => {
    const value = props.component === 'CHECK' ? props.checked : props.value;
    const { control } = (0, react_hook_form_1.useFormContext)();
    const { field, fieldState: { error }, } = (0, react_hook_form_1.useController)({ name: props.name, control });
    (0, react_1.useEffect)(() => {
        if (!(0, utils_1.isNilOrEmpty)(value)) {
            field.onChange(value);
        }
    }, []);
    const handleRadioClick = (code, e) => {
        var _a, _b;
        field.onChange(code);
        (_b = (_a = props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, code, e);
    };
    const handleSelectChange = (code, e) => {
        var _a, _b, _c, _d;
        if ((0, utils_1.isNilOrEmpty)(code)) {
            field.onChange(null);
            (_b = (_a = props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, undefined, e);
        }
        else {
            field.onChange(code);
            (_d = (_c = props).onChange) === null || _d === void 0 ? void 0 : _d.call(_c, code, e);
        }
    };
    const render = (0, react_1.useMemo)(() => {
        const fieldProps = Object.assign({ value: field.value }, (error
            ? {
                message: react_1.default.createElement(ValidationMessage_1.ValidationMessage, { message: error.message, type: error.type }),
                status: Object.values(enums_1.StatusEnum).includes(error.type)
                    ? error.type
                    : enums_1.StatusEnum.error,
            }
            : {}));
        switch (props.component) {
            case 'TEXT':
                return react_1.default.createElement(TextField_1.TextField, Object.assign({}, props, fieldProps, { onChange: field.onChange, onBlur: field.onBlur }));
            case 'CHECK':
                return (react_1.default.createElement(Checkbox_1.Checkbox, Object.assign({}, props, fieldProps, { checked: field.value, onChange: field.onChange, onBlur: field.onBlur })));
            case 'RADIO':
                return react_1.default.createElement(RadioButton_1.RadioButton, Object.assign({}, props, fieldProps, { onClick: handleRadioClick }));
            case 'SELECT':
                return react_1.default.createElement(Selectbox_1.Selectbox, Object.assign({}, props, fieldProps, { onChange: handleSelectChange }));
            case 'DATE':
                return react_1.default.createElement(DatePicker_1.DatePicker, Object.assign({}, props, fieldProps, { onChange: field.onChange }));
            case 'TIME':
                return react_1.default.createElement(TimePicker_1.TimePicker, Object.assign({}, props, fieldProps, { onChange: field.onChange }));
        }
    }, [props, field.value, field.onChange, field.onBlur, error]);
    return react_1.default.createElement("div", { className: "form-field-container" }, render);
};
exports.Field = Field;
